// AvailHandler.h: interface for the AvailHandler class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AVAILHANDLER_H__21ACEE51_E3BD_4756_A40B_48E967456158__INCLUDED_)
#define AFX_AVAILHANDLER_H__21ACEE51_E3BD_4756_A40B_48E967456158__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AvailList_H_
#define __AvailList_H_

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ INCLUDES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#include <string>
#include <fstream>
#include <list>
#include <algorithm>
//#include "Hash.h"
#include "Cache.h"
class Hash;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ TYPES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
struct FreeSpace
{
	int size;
	int reference;
	FreeSpace(int size, int reference){this->size = size;this->reference = reference;}
};

typedef std::string						STRING;
typedef std::list<FreeSpace>::iterator	FREEITER;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ CLASS ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
class AvailHandler
{
friend void eachplayer(FreeSpace * it);

public:
	AvailHandler( Cache * cache, char type);
	~AvailHandler();

	//The return value determine if error has been occured
	void					Add(int size, int reference);
	FreeSpace				findbest(int size);
	void					sort();
	void					loadfromfile();

private:
	// For deleting a node,you should first find it if not found size set to -1
	FREEITER				getIter( int);

	std::list<FreeSpace>	availlist;
	Cache					*cache;
	char					type;
};


#endif


#endif // !defined(AFX_AVAILHANDLER_H__21ACEE51_E3BD_4756_A40B_48E967456158__INCLUDED_)
