// BTree.cpp: implementation of the BTree class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "BTree.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Hash.h"
#include "BTree.h"
#include "Except.h"

STRING vectorer( std::vector<BTNCell *> & a)
{
	STRING retval;

	for(int i = 0;i < a.size();i++)
	{
		retval += a[i]->getKey();
		retval += "   ";
	}

	return retval;
}

BTNCell * vetorir( std::vector<BTNCell *> & a, int i)
{
	return a[i];
}

BTree::BTree( Cache * cache, char type)
:avail( cache, type + 4), buf( cache, type, &avail, '|', '\n')
{
	try
	{
		BTNode * tempol = new BTNode( this, 1);
		root = new BTNCell( this, "", tempol, -1);
		STRING temp;

		temp = buf.directread(0);
		temp.resize(4);
		int i = 0;
		int k = Hash::unpackInt( temp, i);

		if( k != 0)
		{
			root->byteoffset = k;
			root->reference->unpack(buf, k, '|', '\n');
		}

		if( root->reference->mynodes.size() != 0)
			root->key = root->reference->bigest();
	}
	catch(Except & e)
	{
		delete root;
		root = NULL;
		throw;
	}
}

BTree::~BTree()
{
	try
	{
		delete root;
		root = NULL;
	}
	catch(Except & e)
	{
		e.message += "\nDANGER:There is an error in progress of writing your BTree!!";
		delete root;
		root = NULL;
		throw;
	}
}

void BTree::add( STRING key, int ObjectID)
{
	int n = key.size();
	key.resize( n + 4);
	Hash::packInt( key, ObjectID, n);

	if( root->reference->add( key, ObjectID) != 0)
	{
		BTNode * tempchanges = new BTNode( root, new BTNCell( this), this);
		root = new BTNCell( this, "", tempchanges);
		root->reference->mynodes[0]->split( root->reference->mynodes[0], root->reference->mynodes[1]);
//		root->reference->mynodes[0]->cure();
//		root->reference->mynodes[1]->cure();
	}

	root->cure();

	STRING temp;
	int k=0;
	temp.resize(4);
	Hash::packInt(temp,root->byteoffset,k);
	buf.directwrite(temp,0);
}

void BTree::remove( STRING key)
{
	if( root->reference->remove( key) != 0 && root->reference->mynodes.size() == 1 && root->reference->flag != 1)
	{
		BTNCell * temproot = root;
		root = root->reference->mynodes[0];

		int temint = getplacestring( temproot->byteoffset).size();
		deleteplacestring( temproot->byteoffset, temint);
		
		temproot->recursive = 0;
		delete temproot;
	}

	root->cure();

	STRING temp;
	int k=0;
	temp.resize(4);
	Hash::packInt(temp,root->byteoffset,k);
	buf.directwrite(temp,0);
}
//Here efficient

STRING BTree::getplacestring( OFFSET location)
{
	return buf.unpack( location);
}

void BTree::deleteplacestring( OFFSET location, int size)
{
	buf.remove( location, size);
}

OFFSET BTree::putplacestring( STRING newdata)
{
	return buf.pack( newdata);
}

void BTree::out()
{
	root->reference->out();
}

void BTree::find( STRING key)
{
	lastfounds.resize( 0);
	root->reference->find( key);

	if( lastfounds.size() == 0)
		throw NotFound();
}
