// ache.cpp: implementation of the Cache class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Cache.h"
#include "MainFrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include <list>
#include "Person.h"

typedef std::list<Person>	PERSONLIST;

extern STRLIST	mylines;
extern int		horiz;
extern CMainFrame * allpapa;
extern PERSONLIST persons;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Cache.h"
#include "Except.h"
#include <iostream>

STRING intstringstl(long int number);


STRING char2str( const char * input, int count);



Cache::Cache( STRING path, char isnew)
{
	this->path = path;
	lastuse = 1;
	char temp[BUFSIZE];
	for(int k=0 ; k<BUFNUM ; k++)
	{
		last[k]=0;
		offset[k]=-1;
		type[k]=-1;
		changed[k]=0;
	}

	if(isnew)
	{
		_mkdir( path.c_str());
		_chdir( path.c_str());
		log.open((path+"_log.txt").c_str());

		files[0].open( (path+".txt").c_str(), std::ios::out);
		files[1].open( (path+"_hash.txt").c_str(), std::ios::out);
		files[2].open( (path+"_btree1.txt").c_str(), std::ios::out);
		files[3].open( (path+"_btree2.txt").c_str(), std::ios::out);
		files[4].open( (path+"_avail.txt").c_str(), std::ios::out);
		files[5].open( (path+"_hash_avail.txt").c_str(), std::ios::out);
		files[6].open( (path+"_btree1_avail.txt").c_str(), std::ios::out);
		files[7].open( (path+"_btree2_avail.txt").c_str(), std::ios::out);

		buf[0].resize(BUFSIZE);
		buf[1].resize(BUFSIZE);
		buf[1][0] = 1;
		buf[1][8] = (char)248;
		buf[1][12] = 8;

		for(int i=0 ; i<4 ; i++ )
		{
			files[i].write( buf[0].c_str() , buf[0].size() );
			files[i].close();
			log << BUFSIZE << " Bytes write to Offset " << 0 <<" of File " << i << std::endl;
		}

		
		files[5].write( buf[0].c_str() , buf[0].size() );
		files[5].close();
		files[4].write( buf[1].c_str() , buf[1].size() );
		files[4].close();
		files[6].write( buf[1].c_str() , buf[1].size() );
		files[6].close();
		files[7].write( buf[1].c_str() , buf[1].size() );
		files[7].close();
		log << BUFSIZE << " Bytes write to Offset " << 0 <<" of File " << 5 << std::endl;
		log << BUFSIZE << " Bytes write to Offset " << 0 <<" of File " << 4 << std::endl;
		log << BUFSIZE << " Bytes write to Offset " << 0 <<" of File " << 6 << std::endl;
		log << BUFSIZE << " Bytes write to Offset " << 0 <<" of File " << 7 << std::endl;
		
		files[1].open( (path+"_hash.txt").c_str());

		for(i=0 ; i<SPACESIZE ; i++)
		{
			files[1].write(buf[0].c_str() , buf[0].size());
			log << BUFSIZE << " Bytes write to Offset " << i*256 <<" of File " << 1 << std::endl;
		}

		files[1].close();

	}
	else
	{
		log.open((path+"_log.txt").c_str());
	}

	files[0].open( (path+".txt").c_str(), std::ios::in | std::ios::out | std::ios::binary);
	files[1].open( (path+"_hash.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[2].open( (path+"_btree1.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[3].open( (path+"_btree2.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[4].open( (path+"_avail.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[5].open( (path+"_hash_avail.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[6].open( (path+"_btree1_avail.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );
	files[7].open( (path+"_btree2_avail.txt").c_str(), std::ios::in | std::ios::out | std::ios::binary );	

	int i=0;
	for(int j=4; (j<8)&&(i<BUFNUM); j++)
	{
		while(!files[j].eof() && (i<BUFNUM))
		{
			offset[i]=files[j].tellg();
			files[j].read( temp, BUFSIZE);
			type[i]=j;
			last[i]=lastuse++;
			buf[i]=char2str(temp,BUFSIZE);
			if(files[j].good())
			{
				log << BUFSIZE << " Bytes read from Offset " << offset[i] <<" of File " << j << std::endl;
				i++;
			}
		}
	}
	for(j=2; (j<4)&&(i<BUFNUM); j++)
	{
		while(!files[j].eof() && (i<BUFNUM))
		{
			offset[i]=files[j].tellg();
			files[j].read( temp, BUFSIZE);
			type[i]=j;
			last[i]=lastuse++;
			buf[i]=char2str(temp,BUFSIZE);
			if(files[j].good())
			{
				log << BUFSIZE << " Bytes read from Offset " << offset[i] <<" of File " << j << std::endl;
				i++;
			}
		}
	}
	for(j=0; (j<2)&&(i<BUFNUM); j++)
	{
		while(!files[j].eof() && (i<BUFNUM))
		{
			offset[i]=files[j].tellg();
			files[j].read( temp, BUFSIZE);
			type[i]=j;
			last[i]=lastuse++;
			buf[i]=char2str(temp,BUFSIZE);
			if(files[j].good())
			{
				log << BUFSIZE << " Bytes read from Offset " << offset[i] <<" of File " << j << std::endl;
				i++;
			}
		}
	}

	for(i=0 ; i<8 ; i++ )
		files[i].clear();
	for(i=0 ; i<8 ; i++)
	{
		files[i].seekp( 0, std::ios::end );
		size[i] = files[i].tellp();
	}
	for(i=0 ; i<8 ; i++ )
		files[i].clear();
}

Cache::~Cache()
{
	for(int i=0 ; i<BUFNUM ; i++)
	{
		if((type[i]!=-1)&&(changed[i]))
		{
			files[type[i]].seekp(offset[i],std::ios::beg);
			log << BUFSIZE << " Bytes write to Offset " << offset[i] <<" of File " << type[i]+0 << std::endl;
			files[type[i]].write(buf[i].c_str(),BUFSIZE);
			log << "        Buffer " << i <<" Flushes " << std::endl;

		}
	}
	for(i=0 ; i<8 ; i++)
	{
		files[i].close();
	}
	log.close();
}

int Cache::write( char file, OFFSET offset, STRING mustwrite)
{	
	int locat=isInMem(file,(offset-(offset%BUFSIZE)));

	if(locat==-1)
		locat=load(file,(offset-(offset%BUFSIZE)));

	changed[locat]=1;
//	last[locat]=lastuse++;
	for(int j=(offset%BUFSIZE) ; j<mustwrite.size()+(offset%BUFSIZE) ; j++)
		buf[locat][j]=mustwrite[j-(offset%BUFSIZE)];

	return offset;
}

int Cache::read( char file, OFFSET offset, STRING & mustread)
{
	mustread.resize( 0);
	int locat=isInMem(file,(offset-(offset%BUFSIZE)));
	if(locat==-1)
		locat=load(file,(offset-(offset%BUFSIZE)));
	for(int j=(offset%BUFSIZE) ; j<BUFSIZE ; j++)
		mustread += buf[locat][j];

	return offset;
}

int Cache::isInMem( char file, OFFSET location)
{
	for(int i=0 ; i<BUFNUM ; i++)
	{
		if((type[i]==file)&&(offset[i]==location))
			return i;
	}
	return -1;
}

int Cache::getLRU()
{
	int k=0;
	for(int i=1 ; i<BUFNUM ; i++)
	{
		if(last[k]>last[i])
			k = i;
	}

	return k;
}

int Cache::load( char file, OFFSET location)
{
	char temp [BUFSIZE];
	int i=getLRU();

	if((type[i]!=-1)&&(changed[i]))
	{
		files[type[i]].seekp(offset[i],std::ios::beg);
		files[type[i]].write(buf[i].c_str(),BUFSIZE);
		log << BUFSIZE << " Bytes write to Offset " << offset[i] <<" of File " << type[i]+0 << std::endl;
		log << "        Buffer " << i <<" Flushes " << std::endl;

		if(! files[type[i]].good())
			throw Except("ERR:Writing to file!!");
	}

	files[file].seekg(location , std::ios::beg);
	files[file].read(temp,BUFSIZE);
	log << BUFSIZE << " Bytes read from Offset " << location <<" of File " << file+0 << std::endl;

	if(! files[file].good())
		throw Except("ERR:Reading from file!!");

	changed[i]=0;
	type[i]=file;
	buf[i]=char2str(temp,BUFSIZE);
	offset[i]=location;
	last[i]=lastuse++;

	return i;
}


int Cache::write2end( char file, STRING mustwrite)
{
	int i = getLRU();

	if((type[i]!=-1)&&(changed[i]))
	{
		files[type[i]].seekp(offset[i],std::ios::beg);
		files[type[i]].write(buf[i].c_str(),BUFSIZE);
		log << BUFSIZE << " Bytes write to Offset " << offset[i] <<" of File " << type[i]+0 << std::endl;
		log << "        Buffer " << i <<" Flushes " << std::endl;

		if(! files[type[i]].good())
			throw Except("ERR:Writing to file!!");
	}
	
	files[file].seekp( 0, std::ios::end);
	offset[i]=files[file].tellp();
	buf[i].resize( 0);
	buf[i].resize( BUFSIZE);

	for(int j = 0 ; j<mustwrite.size() ; j++)
		buf[i][j]=mustwrite[j];

	files[file].write(buf[i].c_str(),BUFSIZE);
	log << "        Buffer " << i <<" Flushes " << std::endl;
	type[i]=file;
	last[i]=lastuse++;
	changed[i]=1;
	log << BUFSIZE << " Bytes write to Offset " << offset[i] <<" of File " << file+0 << std::endl;


	size[file] += BUFSIZE;

	return offset[i];
}


void Cache::inform()
{
	STRING temp;
	allpapa->outputline( "---------------------------------------- Report -----------------------------------------");
	allpapa->outputline( "");

	files[0].seekp(0,std::ios::end);
	int i=files[0].tellp();
	temp = "    Size of Records File : ";
	temp += intstringstl( i);
	temp += " bytes";
	allpapa->outputline( temp);

	files[1].seekp(0,std::ios::end);
	i=files[1].tellp();
	temp = "    Size of Hash File : ";
	temp += intstringstl( i);
	temp += " bytes";
	allpapa->outputline( temp);

	files[2].seekp(0,std::ios::end);
	i=files[2].tellp();
	temp = "    Size of Last Name's B-Tree File : ";
	temp += intstringstl( i);
	temp += " bytes";
	allpapa->outputline( temp);

	files[3].seekp(0,std::ios::end);
	i=files[3].tellp();
	temp = "    Size of National Code's B-Tree File : ";
	temp += intstringstl( i);
	temp += " bytes";
	allpapa->outputline( temp);

	allpapa->outputline( "");
	allpapa->outputline( "---------------------------------------- Report -----------------------------------------");
}