// Hash.cpp: implementation of the Hash class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Hash.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "Hash.h"
#include "Except.h"

Hash::Hash( Cache * cache, char type)
:avail( cache, type + 4) ,buf( cache, type, &avail)
{
}

Hash::~Hash()
{
}

int Hash::hashCode( int key)
{
	return key % SPACESIZE;
}


int Hash::isEmpty( STRING str)
{
	int ret=1;
	for(int i=0; i<str.size(); i++)
	{
		if(str[i])
			ret = 0;
	}
	return ret;
}


int Hash::addValue( int value, int key)
{
	int place = hashCode(key);
	STRING temp1 ;
	int o = 0;
	temp1.resize(8);
	packInt(temp1,key,o);
	packInt(temp1,value,o);
	place *= (BUCKETSIZE+1)*8;
	STRING temp = buf.directread(place);
	temp.resize((BUCKETSIZE+1)*8);
	unsigned int i=1;
	int x;
	while(i>=0)
	{
		int p=0;
		i=0;
		i=unpackInt(temp,p);
		while((i>=0)&&(p<(BUCKETSIZE+1)*8))
		{	
			if(!i)
			{
				int j = buf.directwrite(temp1,p + place - 4);
				return j;
			}
			p += 4;
			i=unpackInt(temp,p);
		}
		p=BUCKETSIZE*8;
		x = place;
		place = unpackInt(temp,p);
		p+=4;
		if(!place)
		{
			temp1.resize((BUCKETSIZE+1)*8);
			int j = buf.directwrite(temp1);
			int k=0;
			temp1.resize(0);
			temp1.resize(8);
			packInt(temp1,j,k);
			buf.directwrite(temp1,(x+1)*(BUCKETSIZE*8));
			return j;

		}	
		temp = buf.directread(place);
		temp.resize((BUCKETSIZE+1)*8);
	}
	return 0;
}



void Hash::deleteValue( int key)
{
	int place = hashCode(key);
	place *= (BUCKETSIZE+1)*8;
	STRING temp = buf.directread(place);
	temp.resize((BUCKETSIZE+1)*8);
	unsigned int i=1;
	int x = place;
	while(i>=0)
	{
		int p=0;
		i=0;
		i=unpackInt(temp,p);
		while((i>=0)&&(p<(BUCKETSIZE+1)*8))
		{	
			if(i==key)
			{
				buf.remove(place + p - 4);
				for(int k=0;k<8;k++)
				{
					temp[p+k-4] = 0;
				}
				if(isEmpty(temp))
				{
					buf.remove(x+BUCKETSIZE*8,4);
//~~~~~~~~~~~:) :( :l ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~					
					try
					{
						buf.deadbucket(place);
					}
					catch(Except & e)
					{
						if( e.message != "ERR:Trying to delete a primary bucket!!")
							throw;
					}

				}
				return;
			}
			p += 4;
			i=unpackInt(temp,p);
		}
		p=(BUCKETSIZE)*8;
		x=place;
		place = unpackInt(temp,p);
		p+=4;
		if(!place)
			throw Except("Key Not Found !!!\n");
		temp = buf.directread(place);
		temp.resize((BUCKETSIZE+1)*8);
	}
	throw Except("Key Not Found !!!\n");
}

int Hash::getValue( int key)
{
	int place = hashCode(key);
	place *= (BUCKETSIZE+1)*8;
	STRING temp = buf.directread(place);
	temp.resize((BUCKETSIZE+1)*8);
	unsigned int i=1;
	while(i>0)
	{
		int p=0;
		i=0;
		i=unpackInt(temp,p);
		while((i>=0)&&(p<(BUCKETSIZE+1)*8))
		{	
			if(i==key)
				return unpackInt(temp,p);
			i += 4;
			i=unpackInt(temp,p);
		}
		p=(BUCKETSIZE)*8;
		place = unpackInt(temp,p);
		p += 4;
		if(!place)
			throw Except("Key Not Found !!!\n");
		temp = buf.directread(place);
		temp.resize((BUCKETSIZE+1)*8);
	}
	throw Except("Key Not Found !!! \n");
}

void Hash::packInt( STRING & buf, int value, int & place)
{
	int t = value;
//	buf.resize(buf.size()+4);
	buf[place++] = t;
	t >>= 8;
	buf[place++] = t;
	t >>= 8;
	buf[place++] = t;
	t >>= 8;
	buf[place++] = t;
}

int Hash::unpackInt(STRING buf , int & place)
{
	int t=0;
	unsigned char c1 = buf[place++];
	unsigned char c2 = buf[place++];
	unsigned char c3 = buf[place++];
	unsigned char c4 = buf[place++];
	t = c4;
	t <<= 8;
	t += c3;
	t <<= 8;
	t += c2;
	t <<= 8;
	t += c1;
	return t;
}


