// InputForm.cpp : implementation file
//

#include "stdafx.h"
#include "mfc.h"
#include "InputForm.h"
#include "Manager.h"
#include <string>

CString str2mfcstr( STRING what);
CString intstring(long int number);


#define	MAXYEAR		4000
typedef std::string	STRING;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

PERSONLIST persons;

/////////////////////////////////////////////////////////////////////////////
// CInputForm dialog


CInputForm::CInputForm(CWnd* pParent /*=NULL*/, char all)
	: CDialog(CInputForm::IDD, pParent)
{
	getall = all;
	//{{AFX_DATA_INIT(CInputForm)
	m_person_gender = 0;
	//}}AFX_DATA_INIT
}

void CInputForm::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputForm)
	DDX_Radio(pDX, IDC_RADIO_Gender_Male, m_person_gender);
	//}}AFX_DATA_MAP
}

BOOL CInputForm::OnInitDialog()
{
	if( getall != 1)
	{
		CEdit * in = (CEdit*) ( GetDlgItem(IDC_EDIT_First) );//Dlg.IDC_EDIT_First);

		in->SetWindowText( str2mfcstr( persons.begin()->getF_Name()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Last));//Dlg.IDC_EDIT_Last);
		in->SetWindowText( str2mfcstr( persons.begin()->getL_Name()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_National));//Dlg.IDC_EDIT_National);
		in->SetWindowText( str2mfcstr( persons.begin()->getN_Code()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_BirthPlace));//Dlg.IDC_EDIT_BirthPlace);
		in->SetWindowText( str2mfcstr( persons.begin()->getB_Place()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Mother));//Dlg.IDC_EDIT_Mother);
		in->SetWindowText( str2mfcstr( persons.begin()->getMother()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Father));//Dlg.IDC_EDIT_Father);
		in->SetWindowText( str2mfcstr( persons.begin()->getFather()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Year));//Dlg.IDC_EDIT_Year);
		in->SetWindowText( intstring( persons.begin()->getYear()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Mounth));//Dlg.IDC_EDIT_Mounth);
		in->SetWindowText( intstring( persons.begin()->getMounth()));

		in = (CEdit*) ( GetDlgItem(IDC_EDIT_Day));//Dlg.IDC_EDIT_Day);
		in->SetWindowText( intstring( persons.begin()->getDay()));

		if(persons.begin()->getGender() == 'M' || persons.begin()->getGender() == 'm')
			m_person_gender = 0;
		else
			m_person_gender = 1;
	}
	else
		m_person_gender = 0;

	UpdateData( FALSE);

	return TRUE;
}


BEGIN_MESSAGE_MAP(CInputForm, CDialog)
	//{{AFX_MSG_MAP(CInputForm)
	ON_BN_CLICKED(IDOK, OnSubmit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInputForm message handlers

CString str2mfcstr( STRING what)
{

	return what.c_str();
}

STRING mfcstr2str(CString what)
{
	int end = what.GetLength();
	STRING retval;

	for(int count = 0;count < end;count++)
		retval += what[count];

	return retval;
}

CString intstring(long int number)
{
	if(number <= 0)
		return CString('0');

	CString temp;
	int count = 0;

	while(number != 0){
		temp += (number % 10) + '0';
		number /= 10;
	}

	CString temp2;
	int mybegin = temp.GetLength();

	for(count = mybegin - 1;count >= 0;count--)
		temp2 += temp[count];

	return temp2;
}


char containunallowed( CString & str)
{
	int end = str.GetLength();

	for( int count = 0;count < end;count++)
	{
		if( str[count] < '0' || str[count] > '9')
			return 1;
	}

	return 0;
}

int cstr2int( CString & str, int down, int up)
{
	if( containunallowed( str))
		return -1;

	int end = str.GetLength(), retval = 0;

	for( int count = 0;count < end;count++)
		retval = (retval * 10) + (str[count] - '0');

	if( retval < down || retval > up)
		return -1;

	return retval;
}

void CInputForm::OnSubmit() 
{
	UpdateData();

	Person myperson;
	CString tempcs;
	int result;

	CEdit * in = (CEdit*) GetDlgItem( IDC_EDIT_First);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setF_Name( mfcstr2str( tempcs));
	}
	else if( getall == 1)
	{
		MessageBox( "First Name must have value.", "Error", MB_ICONINFORMATION);
		return;
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Last);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setL_Name( mfcstr2str( tempcs));
	}
	else if( getall == 1)
	{
		MessageBox( "Last Name must have value.", "Error", MB_ICONINFORMATION);
		return;
	}

	if ( m_person_gender == 0)
		myperson.setGender( 'm');
	else
		myperson.setGender( 'f');

    in = (CEdit*) GetDlgItem( IDC_EDIT_National);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setN_Code( mfcstr2str( tempcs));
	}
	else if( getall == 1)
	{
		MessageBox( "National Code must have value.", "Error", MB_ICONINFORMATION);
		return;
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_BirthPlace);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setB_Place( mfcstr2str( tempcs));
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Mother);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setMother( mfcstr2str( tempcs));
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Father);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		myperson.setFather( mfcstr2str( tempcs));
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Year);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		result = cstr2int( tempcs, 1, MAXYEAR);

		if( result == -1)
		{
			MessageBox( "The Year value has a problem", "Error", MB_ICONINFORMATION);
			return;
		}

		myperson.setYear( result);
	}
	else if( getall == 1)
	{
		MessageBox( "Date must have proper value.", "Error", MB_ICONINFORMATION);
		return;
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Mounth);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);
		result = cstr2int( tempcs, 1, 12);

		if( result == -1)
		{
			MessageBox( "The Mounth value has a problem", "Error", MB_ICONINFORMATION);
			return;
		}

		myperson.setMounth( result);
	}
	else if( getall == 1)
	{
		MessageBox( "Date must have proper value.", "Error", MB_ICONINFORMATION);
		return;
	}

    in = (CEdit*) GetDlgItem( IDC_EDIT_Day);

	if (in->GetWindowTextLength() != 0)
	{
		tempcs.Empty();
		in->GetWindowText( tempcs);

		if( result < 7)
			result = cstr2int( tempcs, 1, 31);
		else
			result = cstr2int( tempcs, 1, 30);

		if( result == -1)
		{
			MessageBox( "The Day value has a problem", "Error", MB_ICONINFORMATION);
			return;
		}

		myperson.setDay( result);
	}
	else if( getall == 1)
	{
		MessageBox( "Date must have proper value.", "Error", MB_ICONINFORMATION);
		return;
	}

	persons.resize( 0);
	persons.push_back( myperson);
	CDialog::OnOK();
}
