// Person.cpp: implementation of the Person class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "mfc.h"
#include "Person.h"
#include "MainFrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//#include "buffer.h"
#include "Person.h"
#include "Hash.h"
#include "iostream"

STRING intstringstl(long int number);

typedef std::list<STRING> STRLIST;

extern STRLIST	mylines; 
extern int		horiz;
extern CMainFrame * allpapa;


OSTREAM &	operator<<(OSTREAM & out, const Person & person)
{
	out << "-------------------------------------" << std::endl
		<< "Person:" << std::endl
		<< "\tFirst Name:    " << person.F_Name << std::endl
		<< "\tLast Name:     " << person.L_Name << std::endl
		<< "\tGender:        " << ((person.Gender == 'm') ? "Male" : "Female") << std::endl
		<< "\tNational Code: " << person.N_Code << std::endl
		<< "\tBirth Date:    " << person.B_Date << std::endl
		<< "\tBirth Place:   " << person.B_Place << std::endl
		<< "\n\tMother's National Code:  " << person.Mother << std::endl
		<< "\tFather's National Code:  " << person.Father << std::endl
		<< "-------------------------------------" << std::endl;

	return out;
}

OSTREAM &	operator<<(OSTREAM & out, const Date & date)
{
	out << date.day << " / " << date.month << " / " << date.year;

	return out;
}


STRING nextToken( STRING input, int &index, char delim)
{
	STRING temp;
	int f=0;
	if(input[index]=='"')
	{
		index++;
		f=1;
	}
	for(int i=index; ((input[i]!=delim)&&(!f))||((input[i]!='"')&&(f)); i++)
	{
		temp+=input[i];	
	}
	if(f)
		i++;
	index=i;
	return temp;
}


/************************************* Person Class *********************************************/



STRING Person::pack( char fterm, char rterm, char flag)
{
	STRING temp ;
	//packing ObjectID
	if(!flag)
	{
		temp +=	fterm;
		int t = 1;
		temp.resize(5);
		Hash::packInt(temp,ObjectID,t);
		temp +=	fterm;
	}
	temp += F_Name;
	temp +=	fterm;
	temp += L_Name;
	temp +=	fterm;
	temp += Gender;
	temp +=	fterm;
	temp += N_Code;
	temp +=	fterm;
	temp += B_Date.pack(fterm);
	temp +=	fterm;
	temp += B_Place;
	temp +=	fterm;
	temp += Mother;
	temp +=	fterm;
	temp += Father;
	temp +=	fterm;
	temp +=	rterm;
	return temp;
}


void Person::unpack( STRING packed, char fterm, char rterm, int flag)
{
	int index=0;
	int t=flag;

	if(!flag)
	{
		index++;
		t = Hash::unpackInt(packed,index);
		index++;
	}
	ObjectID = t;

	F_Name=nextToken(packed,index,fterm);
	index++;
	L_Name=nextToken(packed,index,fterm);
	index++;
	Gender=nextToken(packed,index,fterm)[0];
	index++;
	N_Code=nextToken(packed,index,fterm);
	index++;
	B_Date.unpack(packed,index,fterm);
	index++;
	B_Place=nextToken(packed,index,fterm);
	index++;
	Mother=nextToken(packed,index,fterm);
	index++;
	Father=nextToken(packed,index,fterm);
}

void Person::getFromConsole()
{
	std::cout << "Enter First Name : ";
	std::cin >>	F_Name;
	std::cout << "Enter Last Name : ";
	std::cin >>	L_Name;
	std::cout << "Enter National Code : ";
	std::cin >>	N_Code;
	std::cout << "Enter Gender (f/m): ";
	std::cin >> Gender ;
	std::cout << "Enter Birth Place : ";
	std::cin >>	B_Place;
	std::cout << "Enter Birthday Day : ";
	std::cin >> B_Date.day ;
	std::cout << "Enter Birthday Month : ";
	std::cin >> B_Date.month ;
	std::cout << "Enter Birthday Year : ";
	std::cin >> B_Date.year ;
	std::cout << "Enter Father's National Code : ";
	std::cin >>	Father;
	std::cout << "Enter Mother's National Code : ";
	std::cin >>	Mother;
}

void Person::tostring()
{
	STRING temp = "--------------------------------------------------------------------------";
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "Person:";
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    First Name:    " + F_Name ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Last Name:     " + L_Name ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Gender:        ";
	temp += ((Gender == 'm') ? "Male" : "Female") ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    National Code: " + N_Code ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Birth Date:    " ;
	temp += intstringstl(B_Date.year) + " / " ;
	temp += intstringstl(B_Date.month) + " / " + intstringstl(B_Date.day) ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Birth Place:   " + B_Place ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Mother's National Code:  " + Mother ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "    Father's National Code:  " + Father ;
	allpapa->outputline(temp);

	temp.resize( 0);
	temp = "--------------------------------------------------------------------------" ;
	allpapa->outputline(temp);

	temp.resize( 0);
}

/******************************************* Date Class ******************************************/

STRING Date::pack( char fterm)
{
	char * k=new char [5];
	STRING temp;
	k = itoa(day,k,10);
	temp += k;
	temp +=	fterm;
	k = itoa(month,k,10);
	temp += k;
	temp +=	fterm;
	k = itoa(year,k,10);
	temp += k;
	delete [] k;
	k = NULL;
	return temp;
}


void Date::unpack( STRING packed, int &index, char fterm)
{
	day=atoi(nextToken(packed,index,fterm).c_str());
	index++;
	month=atoi(nextToken(packed,index,fterm).c_str());
	index++;
	year=atoi(nextToken(packed,index,fterm).c_str());
}

